/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the GoogleBigQueryCustomDtoAuthorizer type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GoogleBigQueryCustomDtoAuthorizer{}

// GoogleBigQueryCustomDtoAuthorizer struct for GoogleBigQueryCustomDtoAuthorizer
type GoogleBigQueryCustomDtoAuthorizer struct {
	Label        *string `json:"label,omitempty"`
	ClientId     *string `json:"clientId,omitempty"`
	ClientSecret *string `json:"clientSecret,omitempty"`
	RedirectUri  *string `json:"redirectUri,omitempty"`
}

// NewGoogleBigQueryCustomDtoAuthorizer instantiates a new GoogleBigQueryCustomDtoAuthorizer object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGoogleBigQueryCustomDtoAuthorizer() *GoogleBigQueryCustomDtoAuthorizer {
	this := GoogleBigQueryCustomDtoAuthorizer{}
	return &this
}

// NewGoogleBigQueryCustomDtoAuthorizerWithDefaults instantiates a new GoogleBigQueryCustomDtoAuthorizer object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGoogleBigQueryCustomDtoAuthorizerWithDefaults() *GoogleBigQueryCustomDtoAuthorizer {
	this := GoogleBigQueryCustomDtoAuthorizer{}
	return &this
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *GoogleBigQueryCustomDtoAuthorizer) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleBigQueryCustomDtoAuthorizer) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *GoogleBigQueryCustomDtoAuthorizer) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *GoogleBigQueryCustomDtoAuthorizer) SetLabel(v string) {
	o.Label = &v
}

// GetClientId returns the ClientId field value if set, zero value otherwise.
func (o *GoogleBigQueryCustomDtoAuthorizer) GetClientId() string {
	if o == nil || IsNil(o.ClientId) {
		var ret string
		return ret
	}
	return *o.ClientId
}

// GetClientIdOk returns a tuple with the ClientId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleBigQueryCustomDtoAuthorizer) GetClientIdOk() (*string, bool) {
	if o == nil || IsNil(o.ClientId) {
		return nil, false
	}
	return o.ClientId, true
}

// HasClientId returns a boolean if a field has been set.
func (o *GoogleBigQueryCustomDtoAuthorizer) HasClientId() bool {
	if o != nil && !IsNil(o.ClientId) {
		return true
	}

	return false
}

// SetClientId gets a reference to the given string and assigns it to the ClientId field.
func (o *GoogleBigQueryCustomDtoAuthorizer) SetClientId(v string) {
	o.ClientId = &v
}

// GetClientSecret returns the ClientSecret field value if set, zero value otherwise.
func (o *GoogleBigQueryCustomDtoAuthorizer) GetClientSecret() string {
	if o == nil || IsNil(o.ClientSecret) {
		var ret string
		return ret
	}
	return *o.ClientSecret
}

// GetClientSecretOk returns a tuple with the ClientSecret field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleBigQueryCustomDtoAuthorizer) GetClientSecretOk() (*string, bool) {
	if o == nil || IsNil(o.ClientSecret) {
		return nil, false
	}
	return o.ClientSecret, true
}

// HasClientSecret returns a boolean if a field has been set.
func (o *GoogleBigQueryCustomDtoAuthorizer) HasClientSecret() bool {
	if o != nil && !IsNil(o.ClientSecret) {
		return true
	}

	return false
}

// SetClientSecret gets a reference to the given string and assigns it to the ClientSecret field.
func (o *GoogleBigQueryCustomDtoAuthorizer) SetClientSecret(v string) {
	o.ClientSecret = &v
}

// GetRedirectUri returns the RedirectUri field value if set, zero value otherwise.
func (o *GoogleBigQueryCustomDtoAuthorizer) GetRedirectUri() string {
	if o == nil || IsNil(o.RedirectUri) {
		var ret string
		return ret
	}
	return *o.RedirectUri
}

// GetRedirectUriOk returns a tuple with the RedirectUri field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleBigQueryCustomDtoAuthorizer) GetRedirectUriOk() (*string, bool) {
	if o == nil || IsNil(o.RedirectUri) {
		return nil, false
	}
	return o.RedirectUri, true
}

// HasRedirectUri returns a boolean if a field has been set.
func (o *GoogleBigQueryCustomDtoAuthorizer) HasRedirectUri() bool {
	if o != nil && !IsNil(o.RedirectUri) {
		return true
	}

	return false
}

// SetRedirectUri gets a reference to the given string and assigns it to the RedirectUri field.
func (o *GoogleBigQueryCustomDtoAuthorizer) SetRedirectUri(v string) {
	o.RedirectUri = &v
}

func (o GoogleBigQueryCustomDtoAuthorizer) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GoogleBigQueryCustomDtoAuthorizer) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.ClientId) {
		toSerialize["clientId"] = o.ClientId
	}
	if !IsNil(o.ClientSecret) {
		toSerialize["clientSecret"] = o.ClientSecret
	}
	if !IsNil(o.RedirectUri) {
		toSerialize["redirectUri"] = o.RedirectUri
	}
	return toSerialize, nil
}

type NullableGoogleBigQueryCustomDtoAuthorizer struct {
	value *GoogleBigQueryCustomDtoAuthorizer
	isSet bool
}

func (v NullableGoogleBigQueryCustomDtoAuthorizer) Get() *GoogleBigQueryCustomDtoAuthorizer {
	return v.value
}

func (v *NullableGoogleBigQueryCustomDtoAuthorizer) Set(val *GoogleBigQueryCustomDtoAuthorizer) {
	v.value = val
	v.isSet = true
}

func (v NullableGoogleBigQueryCustomDtoAuthorizer) IsSet() bool {
	return v.isSet
}

func (v *NullableGoogleBigQueryCustomDtoAuthorizer) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGoogleBigQueryCustomDtoAuthorizer(val *GoogleBigQueryCustomDtoAuthorizer) *NullableGoogleBigQueryCustomDtoAuthorizer {
	return &NullableGoogleBigQueryCustomDtoAuthorizer{value: val, isSet: true}
}

func (v NullableGoogleBigQueryCustomDtoAuthorizer) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGoogleBigQueryCustomDtoAuthorizer) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
